-- Chamferizer 1.0 for MAX 2.0
-- by Jarek Dukat
-- http://www.nautilus.com.pl/jarek
-- jarek@nautilus.com.pl

utility chamferizer "Chamferizer 1.0"
(
	pickbutton chbox "Chamferize  BOX" filter:validbox width:140 height:19 tooltip:"Pick Box object to change into ChamferBox"
	button chboxall "All  BOXes" width:120 height:19 tooltip:"Change all Boxes in scene into ChamferBox"
	pickbutton chcyl "Chamferize  CYLINDER" filter:validcyl width:140 height:19 tooltip:"Pick Cylinder object to change into ChamferCylinder" offset:[0,4]
	button chcylall "All  CYLINDERs" width:120 height:19 tooltip:"Change all Cylinders in scene into ChamferCylinder"
	checkbox chdel "Delete non-chamfered" checked:true
	spinner chfil "Fillet amount: " range:[1,100,20] type:#integer fieldwidth:32
	spinner chfsg "Fillet segments: " range:[1,50,4] type:#integer fieldwidth:32
	button chundo "Undo"

	group "About Chamferizer" (
		label ab1 "Chamferizer 1.0 for MAX 2.0"
		label ab2 "by Jarek Dukat"
		label ab3 "www.nautilus.com.pl/jarek"
		label ab4 "jarek@nautilus.com.pl"
	)
	
	on chundo pressed do max undo
	on chboxall pressed do undo on (ch_boxall())
	on chbox picked node do undo on (ch_box node)
	on chcylall pressed do undo on (ch_cylall())
	on chcyl picked node do undo on (ch_cyl node)
)

fn validbox obj = classof obj == box
fn validcyl obj = classof obj == cylinder

fn ch_box node =
	(
		nbox = chamferbox pos:node.pos height:node.height length:node.length \
			width:node.width Length_Segments:node.LengthSegs Width_Segments:node.WidthSegs \
			Height_Segments:node.HeightSegs name:node.name wirecolor:node.wirecolor \
			Fillet_Segments:chamferizer.chfsg.value \
			boxMode:node.boxMode allEdges:node.allEdges backFaceCull:node.backFaceCull \
			castShadows:node.castShadows receiveShadows:node.receiveShadows gbufferChannel:node.gbufferChannel \
			visibility:node.visibility motionBlur:node.motionBlur imageMotionBlurMultiplier:node.imageMotionBlurMultiplier \
			showLinks:node.showLinks showLinksOnly:node.showLinksOnly showTrajectory:node.showTrajectory \
			renderable:node.renderable showVertexColors:node.showVertexColors vertexColorsShaded:node.vertexColorsShaded \
			node.inheritVisibility
		nbox.parent = node.parent
		nbox.pos.controller = node.pos.controller
		nbox.rotation.controller = node.rotation.controller
		nbox.scale.controller = node.scale.controller
		if node.material!=undefined do nbox.material = node.material
		s = if (node.width<node.height) then node.width else node.height
		s = if (s<node.length) then s else node.length
		nbox.fillet = (s * chamferizer.chfil.value / 200)
		if chamferizer.chdel.checked do delete node
	)

fn ch_cyl node =
	(
		ncyl = chamfercyl pos:node.pos \
		height:node.height \
		radius:node.radius \
			Cap_Segments:node.Capsegs sides:node.sides \
			Smooth_On:(if node.Smooth then 1 else 0) \
			Slice_From:node.SliceFrom Slice_To:node.SliceTo \
			Height_Segments:node.HeightSegs name:node.name wirecolor:node.wirecolor \
			Fillet_Segments:chamferizer.chfsg.value \
			boxMode:node.boxMode allEdges:node.allEdges backFaceCull:node.backFaceCull \
			castShadows:node.castShadows receiveShadows:node.receiveShadows gbufferChannel:node.gbufferChannel \
			visibility:node.visibility motionBlur:node.motionBlur imageMotionBlurMultiplier:node.imageMotionBlurMultiplier \
			showLinks:node.showLinks showLinksOnly:node.showLinksOnly showTrajectory:node.showTrajectory \
			renderable:node.renderable showVertexColors:node.showVertexColors vertexColorsShaded:node.vertexColorsShaded \
			node.inheritVisibility
		ncyl.parent = node.parent
		ncyl.pos.controller = node.pos.controller
		ncyl.rotation.controller = node.rotation.controller
		ncyl.scale.controller = node.scale.controller
		if node.material!=undefined do ncyl.material = node.material
		s = if (2*node.radius)<node.height then (2*node.radius) else node.height
		ncyl.fillet = (s * chamferizer.chfil.value / 200)
		if chamferizer.chdel.checked do delete node
	)

fn ch_boxall = (
	for i = 1 to objects.count do (
		if (classof objects[i] == box) do (
			ch_box objects[i]
			ch_boxall()
		)
	)
)

fn ch_cylall = (
	for i = 1 to objects.count do (
		if (classof objects[i] == cylinder) do (
			ch_cyl objects[i]
			ch_cylall()
		)
	)
)
